# Journey Across Pythonia Wild Plains Mini-Game!

import pygame
pygame.init()

win = pygame.display.set_mode((500, 480))

pygame.display.set_caption("Python Clan vs. Shell Clan")

programIcon = pygame.image.load('icon.png')
pygame.display.set_icon(programIcon)

walkRight = [pygame.image.load('characters/player/R1.png'), pygame.image.load('characters/player/R2.png'), pygame.image.load('characters/player/R3.png'), pygame.image.load('characters/player/R4.png'), pygame.image.load('characters/player/R5.png'), pygame.image.load('characters/player/R6.png'), pygame.image.load('characters/player/R7.png'), pygame.image.load('characters/player/R8.png'), pygame.image.load('characters/player/R9.png')]
walkLeft = [pygame.image.load('characters/player/L1.png'), pygame.image.load('characters/player/L2.png'), pygame.image.load('characters/player/L3.png'), pygame.image.load('characters/player/L4.png'), pygame.image.load('characters/player/L5.png'), pygame.image.load('characters/player/L6.png'), pygame.image.load('characters/player/L7.png'), pygame.image.load('characters/player/L8.png'), pygame.image.load('characters/player/L9.png')]
bg = pygame.image.load('world/bg.jpg')
winner = pygame.image.load('world/winner.jpg')
lose = pygame.image.load('world/lose.jpg')
start = pygame.image.load('world/start.jpg')

clock = pygame.time.Clock()

screenWidth = 500

rockSound = pygame.mixer.Sound('audio/rock.wav')
hitSound = pygame.mixer.Sound('audio/hit.wav')
playerHit = pygame.mixer.Sound('audio/playerhit.wav')
ticking = pygame.mixer.Sound('audio/ticking.wav')
jumpSound = pygame.mixer.Sound('audio/jump.wav')
respawnSound = pygame.mixer.Sound('audio/respawn.wav')

music = pygame.mixer.music.load('audio/music.wav')
pygame.mixer.music.play(-1)

player_health = 100
enemy_count = 10

class player(object):
    def __init__(self,x,y,width,height):
        self.x = x
        self.y = y
        self.width = width
        self.height = height
        self.vel = 5
        self.isJump = False
        self.left = False
        self.right = False
        self.walkCount = 0
        self.deathCount = 0
        self.jumpCount = 10
        self.standing = True
        self.hitbox = (self.x + 17, self.y + 11, 29, 52)

    def draw(self, win):
        if self.walkCount + 1 >= 27:
            self.walkCount = 0
        if not(self.standing):
            if self.right:
                win.blit(walkRight[self.walkCount//3], (self.x,self.y))
                self.walkCount +=1
            elif self.left:
                win.blit(walkLeft[self.walkCount//3], (self.x,self.y))
                self.walkCount += 1            
        else:
            if self.left:
                win.blit(walkLeft[0], (self.x, self.y))
            else:
                win.blit(walkRight[0], (self.x, self.y))
        
        self.hitbox = (self.x + 17, self.y + 11, 29, 52)
        #pygame.draw.rect(win, (255,0,0), self.hitbox, 2)
    
    def hit(self):
        self.isJump = False
        self.jumpCount = 10
        self.x = 20
        self.y = 410
        self.walkCount = 0
        font1 = pygame.font.SysFont('comicsans', 100)
        text = font1.render('-5', 1, (255,0,0))
        win.blit(text, (250 - (text.get_width()/2),200))
        pygame.display.update()
        i = 0
        while i < 100:
            pygame.time.delay(10)
            i += 1
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    i = 101
                    pygame.quit()
    
class projectile(object):
    def __init__(self,x,y,radius,color,facing):
        self.x = x
        self. y = y 
        self. radius = radius 
        self. color = color 
        self. facing = facing
        self.vel = 8 * facing 
        
    def draw(self,win):
        pygame.draw.circle(win, self.color, (self.x,self.y), self.radius)
        
class enemy(object):
    walkRight = [pygame.image.load('characters/snake/R1E.png'), pygame.image.load('characters/snake/R2E.png'), pygame.image.load('characters/snake/R3E.png'), pygame.image.load('characters/snake/R4E.png'), pygame.image.load('characters/snake/R5E.png'), pygame.image.load('characters/snake/R6E.png'), pygame.image.load('characters/snake/R7E.png'), pygame.image.load('characters/snake/R8E.png'), pygame.image.load('characters/snake/R9E.png'), pygame.image.load('characters/snake/R10E.png'), pygame.image.load('characters/snake/R11E.png')]
    walkLeft = [pygame.image.load('characters/snake/L1E.png'), pygame.image.load('characters/snake/L2E.png'), pygame.image.load('characters/snake/L3E.png'), pygame.image.load('characters/snake/L4E.png'), pygame.image.load('characters/snake/L5E.png'), pygame.image.load('characters/snake/L6E.png'), pygame.image.load('characters/snake/L7E.png'), pygame.image.load('characters/snake/L8E.png'), pygame.image.load('characters/snake/L9E.png'), pygame.image.load('characters/snake/L10E.png'), pygame.image.load('characters/snake/L11E.png')]
    
    def __init__(self, x, y, width, height, end):
        self.x = x
        self.y = y
        self.width = width 
        self.height = height 
        self.end = end
        self.path = [self.x, self.end]
        self.walkCount = 0
        self.vel = 1
        self.hitbox = (self.x + 17, self.y + 2, 31, 57)
        self.health = 10
        self.visible = True
        self.respawning = False
    
    def draw(self, win):
        self.move()
        if self.respawning:
            i = 100
            while i > 0:
                self.walkCount = 0
                i -= 1
            else:
                self.respawning = False            
        else:            
            if self.visible:
                if self.walkCount + 1 >= 33:
                    self.walkCount = 0
                if self.vel > 0:
                    win.blit(self.walkRight[self.walkCount //3], (self.x, self.y))
                    self.walkCount += 1
                else:
                    win.blit(self.walkLeft[self.walkCount //3], (self.x, self.y))
                    self.walkCount += 1
                pygame.draw.rect(win, (255,0,0), (self.hitbox[0], self.hitbox[1] - 20, 50, 10))
                pygame.draw.rect(win, (0,128,0), (self.hitbox[0], self.hitbox[1] - 20, 50 - (5 * (10 - self.health)), 10))
                self.hitbox = (self.x + 17, self.y + 2, 31, 57)
                #pygame.draw.rect(win, (255,0,0), self.hitbox,2)
    
    def move(self):
        if self.vel > 0:
            if self.x + self.vel < self.path[1]:
                self.x += self.vel
            else:
                self.vel = self.vel * -1
                self.walkCount = 0
        else:
            if self.x - self.vel > self.path[0]:
                self.x += self.vel
            else:
                self.vel = self.vel * -1
                self.walkCount = 0
    
    def hit(self):
        if self.health > 0:
            self.health -= 0.5
        else:
            self.visible = False
        print("hit")
    
    def respawn(self):
        print ('respawning')
        self.respawning = True
        self.health += 10
        self.visible = True
        
class enemy2(object):
    walkRight = [pygame.image.load('characters/snake/R1E.png'), pygame.image.load('characters/snake/R2E.png'), pygame.image.load('characters/snake/R3E.png'), pygame.image.load('characters/snake/R4E.png'), pygame.image.load('characters/snake/R5E.png'), pygame.image.load('characters/snake/R6E.png'), pygame.image.load('characters/snake/R7E.png'), pygame.image.load('characters/snake/R8E.png'), pygame.image.load('characters/snake/R9E.png'), pygame.image.load('characters/snake/R10E.png'), pygame.image.load('characters/snake/R11E.png')]
    walkLeft = [pygame.image.load('characters/snake/L1E.png'), pygame.image.load('characters/snake/L2E.png'), pygame.image.load('characters/snake/L3E.png'), pygame.image.load('characters/snake/L4E.png'), pygame.image.load('characters/snake/L5E.png'), pygame.image.load('characters/snake/L6E.png'), pygame.image.load('characters/snake/L7E.png'), pygame.image.load('characters/snake/L8E.png'), pygame.image.load('characters/snake/L9E.png'), pygame.image.load('characters/snake/L10E.png'), pygame.image.load('characters/snake/L11E.png')]
    
    def __init__(self, x, y, width, height, end):
        self.x = x
        self.y = y
        self.width = width 
        self.height = height 
        self.end = end
        self.path = [self.x, self.end]
        self.walkCount = 0
        self.vel = 1
        self.hitbox = (self.x + 17, self.y + 2, 31, 57)
        self.health = 10
        self.visible = True
        self.respawning = False
    
    def draw(self, win):
        self.move()
        if self.respawning:
            i = 100
            while i > 0:
                self.walkCount = 0
                i -= 1
            else:
                self.respawning = False            
        else:            
            if self.visible:
                if self.walkCount + 1 >= 33:
                    self.walkCount = 0
                if self.vel > 0:
                    win.blit(self.walkRight[self.walkCount //3], (self.x, self.y))
                    self.walkCount += 1
                else:
                    win.blit(self.walkLeft[self.walkCount //3], (self.x, self.y))
                    self.walkCount += 1
                pygame.draw.rect(win, (255,0,0), (self.hitbox[0], self.hitbox[1] - 20, 50, 10))
                pygame.draw.rect(win, (0,128,0), (self.hitbox[0], self.hitbox[1] - 20, 50 - (5 * (10 - self.health)), 10))
                self.hitbox = (self.x + 17, self.y + 2, 31, 57)
                #pygame.draw.rect(win, (255,0,0), self.hitbox,2)
    
    def move(self):
        if self.vel > 0:
            if self.x + self.vel < self.path[1]:
                self.x += self.vel
            else:
                self.vel = self.vel * -1
                self.walkCount = 0
        else:
            if self.x - self.vel > self.path[0]:
                self.x += self.vel
            else:
                self.vel = self.vel * -1
                self.walkCount = 0
    
    def hit(self):
        if self.health > 0:
            self.health -= 0.5
        else:
            self.visible = False
        print("hit")
    
    def respawn(self):
        print ('respawning')
        self.respawning = True
        self.health += 10
        self.visible = True
        
def redrawGameWindow():
    global player_health
    win.blit(bg,(0,0))
    text = font.render('Health: ' + str(player_health), 1, (0,0,0))
    win.blit(text, (350, 10))
    text2 = font.render('Pythons: ' + str(enemy_count), 1, (0,0,0))
    win.blit(text2, (350, 40))
    turtle.draw(win)
    snake.draw(win)
    snake2.draw(win)
    for rock in rocks:
        rock.draw(win)
    if turtle.x <= 50:
        font3 = pygame.font.SysFont('comicsans', 50)
        text = font3.render('PYTHON TERRITORY!', 1, (255,0,0))
        win.blit(text, (250 - (text.get_width()/2),200))
        ticking.play(-1)
        player_health -= 1
        pygame.display.update()
    else:
        ticking.stop()
    pygame.display.update()

def drawGameOver():
    global player_health
    global enemy_count
    run = False
    game_over = True
    while game_over:
        clock.tick(27)        
        win.blit(lose, (0,0))
        pygame.display.update()
        ticking.stop()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
            if event.type==pygame.KEYDOWN:
                if event.key==pygame.K_RETURN:
                    player_health = 100
                    enemy_count = 10
                    snake.health = 10
                    snake2.health = 10
                    turtle.x = 300
                    turtle.y = 410
                    snake.x = 150
                    snake.y = 410
                    snake2.x = 50
                    snake2.y = 410
                    run = True
                    game_over = False
    
def drawYouWin():
    global player_health
    global enemy_count
    run = False
    you_win = True
    while you_win:
        clock.tick(27)        
        win.blit(winner, (0,0))
        pygame.display.update()
        ticking.stop()
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
            if event.type==pygame.KEYDOWN:
                if event.key==pygame.K_RETURN:
                    player_health = 100
                    enemy_count = 10
                    snake.health = 10
                    snake2.health = 10
                    turtle.x = 300
                    turtle.y = 410
                    snake.x = 150
                    snake.y = 410
                    snake2.x = 50
                    snake2.y = 410
                    run = True
                    you_win = False

# Start Screen
intro = True
run = False
while intro:
    clock.tick(27)        
    win.blit(start, (0,0))
    pygame.display.update()
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            pygame.quit()
        if event.type==pygame.KEYDOWN:
            if event.key==pygame.K_RETURN:
                pygame.time.wait(1000)
                intro = False
                run = True
    
# Main Loop
font = pygame.font.SysFont('comicsans', 30, True)
turtle = player(300, 410, 64, 64)
snake = enemy(150, 410, 64, 64, 475)
snake2 = enemy2(50, 410, 64, 64, 450)
shootLoop = 0
rocks = []
while run:
    clock.tick(27)
        
    if player_health > 0 and enemy_count > 0: # Gameplay
    
        if snake.visible == True:
            if turtle.hitbox[1] < snake.hitbox[1] + snake.hitbox[3] and turtle.hitbox[1] + turtle.hitbox[3] > snake.hitbox[1]:
                if turtle.hitbox[0] + turtle.hitbox[2] > snake.hitbox[0] and turtle.hitbox[0] < snake.hitbox[0] + snake.hitbox[2]:
                    playerHit.play()
                    turtle.hit()
                    player_health -= 5
        else:
            enemy_count -= 1
            respawnSound.play()
            snake.respawn()
        
        if snake2.visible == True:
            if turtle.hitbox[1] < snake2.hitbox[1] + snake2.hitbox[3] and turtle.hitbox[1] + turtle.hitbox[3] > snake2.hitbox[1]:
                if turtle.hitbox[0] + turtle.hitbox[2] > snake2.hitbox[0] and turtle.hitbox[0] < snake2.hitbox[0] + snake2.hitbox[2]:
                    playerHit.play()
                    turtle.hit()
                    player_health -= 5
        else:
            enemy_count -= 1
            respawnSound.play()
            snake2.respawn()
        
        if shootLoop > 0:
            shootLoop +=1
        if shootLoop > 3:
            shootLoop = 0
            
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                run = False
                
        for rock in rocks:
            if rock.y - rock.radius < snake.hitbox[1] + snake.hitbox[3] and rock.y + rock.radius > snake.hitbox[1]:
                if rock.x + rock.radius > snake.hitbox[0] and rock.x - rock.radius < snake.hitbox[0] + snake.hitbox[2]:
                    hitSound.play()
                    snake.hit()
                    rocks.pop(rocks.index(rock))
            if rock.x < 500 and rock.x > 0:
                rock.x += rock.vel
            else:
                rocks.pop(rocks.index(rock))    
        
        for rock in rocks:
            if rock.y - rock.radius < snake2.hitbox[1] + snake2.hitbox[3] and rock.y + rock.radius > snake2.hitbox[1]:
                if rock.x + rock.radius > snake2.hitbox[0] and rock.x - rock.radius < snake2.hitbox[0] + snake2.hitbox[2]:
                    hitSound.play()
                    snake2.hit()
                    rocks.pop(rocks.index(rock))
            if rock.x < 500 and rock.x > 0:
                rock.x += rock.vel
            else:
                rocks.pop(rocks.index(rock))
                
        keys = pygame.key.get_pressed()
        
        if keys[pygame.K_SPACE] and shootLoop == 0:
            rockSound.play()
            if turtle.left:
                facing = -1
            else:
                facing = 1
            if len(rocks) < 5:
                rocks.append(projectile(round(turtle.x + turtle.width //2), round(turtle.y + turtle.height //2), 6, (0,0,0), facing))
            shootLoop = 1
        if keys[pygame.K_LEFT] and turtle.x > turtle.vel:
            turtle.x -= turtle.vel
            turtle.left = True
            turtle.right = False
            turtle.standing = False
        elif keys[pygame.K_RIGHT] and turtle.x < screenWidth - turtle.width - turtle.vel:
            turtle.x += turtle.vel
            turtle.left = False
            turtle.right = True
            turtle.standing = False
        else:
            turtle.standing = True
            turtle.walkCount = 0
        if not(turtle.isJump):
            if keys[pygame.K_UP]:
                turtle.isJump = True
                turtle.right = False
                turtle.left = False
                jumpSound.play()
                turtle.walkCount = 0
        else:
            if turtle.jumpCount >= -10:
                neg = 1
                if turtle.jumpCount < 0:
                    neg = -1
                turtle.y -= (turtle.jumpCount ** 2) * 0.5 * neg
                turtle.jumpCount -= 1
            else:
                turtle.isJump = False
                turtle.jumpCount = 10
    
    else: # End of Game
        if player_health > 0:
            drawYouWin()
        else:
            drawGameOver()
    
    redrawGameWindow()    


pygame.quit()
